//+------------------------------------------------------------------+
//|                                                   STI_v2_0_2.mq4 |
//|                                                                  |
//|                     developed by Joke modified by Nicholishen    |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "www.forex-tsd.com"
#define MAGICMA  20060224

#include <stdlib.mqh>
#include <WinUser32.mqh>



/*
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Additions:

TotalEquitySL= This feature sets a total stoploss on entire account.  If account equity grows to a certain point and then drops
below the alowable draw down percentage AND there are no open trades then trading is suspended until human intervention.

ScalpIt = Brokers typically won't allow tight TP.  This feature will allow you to set any TP.

StepTrail= This feature will set the new stop loss after the Trail1Step level is hit.  The new stop is at the profit level
minus the flex.  It will step in increments of the (Trail1Step).
 
TradTrail= This is the Traditional Trailing Stop.

UseCCI= Only trades when CCI signal <100 && >-100

UseMailAlerts= Will email the details of the trade as it hits the history window regardless of whether or not EA closes or 
trade is closed by SL/TP

UseTimeFilter= If there are no pending trades AND Time is < Begin OR > End  then Trading is suspended

Reverse Trade Signal= reverses opening and closing criteria

You are now able to trade:
a)Multiple Pairs
b)Multiple TF on Same pair same platform
c)Multiple settings on (a) and/or (b) at the same time

System will automatically log trade settings and all trades associated with those settings. 
Logs can be found in the experts/files folder. File can be opened with Excel
for further analysis

TEST AWAY!       =) Nicholishen
*/
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   extern bool UseEmailAlerts=true;
   extern bool UseTotalEquitySL=false;
   extern double EquityRisk=50;
   extern double lots=0.1;              
   extern int TakeProfit=6;             
   extern int StopLoss=50;             
              
   extern bool UseScalpIt=false;
   extern int ScalpPips=3;
   extern bool UseStepTrail=false;
   extern int Trail1Step=6;
   extern int Flex=2;
  
   extern bool UseTradTrail    = true; 
   extern bool ProfitTrailing = true;   
   extern int  TrailingStop   = 6;    
   extern int  TrailingStep   = 3;  

   extern int N1=3;            
   extern int N2=2;
               
  
   extern bool UseCCI=false;
   extern bool UseTimeFilter=false;
   extern int BeginHour=8;
   extern int EndHour=18;
   extern bool ReverseTradeSignal=false;
   extern string FileSavePrefix="STI";
   
   int TestStart;
   int k;
   int mm,dd,yy,hh,min,ss,tf;
   string comment;
   string syym;
   
int deinit()
  {
 // ObjectsDeleteAll(0,OBJ_ARROW);
 // ObjectsDeleteAll(0,OBJ_HLINE);
 
 //if(GlobalVariableCheck("STI")==false) GlobalVariableSet("STI",0);
 int TestStop=CurTime();
// int num=GlobalVariableGet("STI")+1;
 
 //string filename="STI_"+num+".csv";
 string filename=FileSavePrefix+"_"+yy+"_"+mm+"_"+dd+"_"+hh+"_"+min+"_"+syym+"_"+tf+".csv";
 
 //if(GlobalVariableCheck("STI")==false) GlobalVariableSet("STI",0);
 
 int h1=FileOpen(filename,FILE_CSV|FILE_WRITE,',');
 FileWrite(h1,
"UseEmailAlerts","UseTotalEquitySL","EquityRisk","lots","TakeProfit","StopLoss","UseScalpIt","ScalpPips",
"UseStepTrail","Trail1Step","Flex","UseTradTrail","ProfitTrailing","TrailingStop","TrailingStep", "N1","N2","UseCCI","UseTimeFilter","BeginHour", "EndHour","ReverseTradeSignal",
"TestStart","TestStop","TotalProfit");
 
 
 FileWrite(h1,
UseEmailAlerts,UseTotalEquitySL,EquityRisk,lots,TakeProfit,StopLoss,UseScalpIt,ScalpPips,
UseStepTrail,Trail1Step,Flex,UseTradTrail,ProfitTrailing,TrailingStop,TrailingStep, N1,N2,UseCCI,UseTimeFilter,BeginHour, EndHour,ReverseTradeSignal,
TimeToStr(TestStart,TIME_DATE|TIME_SECONDS),TimeToStr(TestStop,TIME_DATE|TIME_SECONDS),TotalProfit(TestStart,TestStop));

 FileWrite(h1,"");  
 FileWrite(h1,"TRADES");
 FileWrite(h1,"Order","OpenTime", "Type","Lots","Symbol","Price","SL","TP","Time","ClosePrice","Swap","Profit");
 /////////////
   double pr=0;
   for(int i=0;i<10000;i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() ==comment ){
            if(OrderOpenTime() >= TestStart){
            if(OrderType()==OP_BUY){string typ="BUY";}else{typ="SELL";}
            FileWrite(h1,OrderTicket(),TimeToStr(OrderOpenTime(),TIME_DATE|TIME_SECONDS),typ,OrderLots(),OrderSymbol(),OrderOpenPrice(),OrderStopLoss(),
            OrderTakeProfit(),TimeToStr(OrderCloseTime(),TIME_DATE|TIME_SECONDS),OrderClosePrice(),OrderSwap(),OrderProfit() );
            }
         }
      }else{
         break;
      }  
   }
//////////////
 
// GlobalVariableSet("STI",GlobalVariableGet("STI")+1);          
//---- 
  return;
  }
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   if(!GlobalVariableCheck("STI")) GlobalVariableSet("STI",1);
   int ggg=GlobalVariableGet("STI");
   string gv=DoubleToStr(ggg,0);
   string sy=Symbol();
   
   
   comment="STI_"+gv;
   GlobalVariableSet("STI",ggg+1);
   
   mm=Month();dd=Day();yy=Year();min=Minute();hh=Hour();ss=Seconds();syym=Symbol();tf=Period();
   TestStart=CurTime();
   for(int i=0;i<1000;i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() ==comment ){
            k++;
         }
      }else{
         break;
      }  
   }
//Comment("\n","SYSTEM INITIALIZED ");   
//Comment(comment);

double PDmax[50], PDmin[50], minmin, maxmax, stMAINPrev, stSIGPrev, sl, tp;
int    res, error, skUp, skDn, UD ;
bool   UpPD[50], DnPD[50];
      
for (int k=1; k<=50; k++){   
   UpPD[k]=True;
   DnPD[k]=True;
   PDmax[k]=High[N1+k];
   PDmin[k]=Low[N1+k];
   
   for (int d=1; d<=N1; d++) {
      if (PDmax[k]>High[N1+k+d] && UpPD[k]==True) {
         if (PDmin[k]<Low[N1+k-d] && UpPD[k]==True) {
            UpPD[k]=True;
         }
         else
            UpPD[k]=False;
      }
      else
         UpPD[k]=False;
      if (PDmax[k]>High[N1+k-d] && DnPD[k]==True) {
         if (PDmin[k]<Low[N1+k+d] && DnPD[k]==True)  {
            DnPD[k]=True;
         }
         else
            DnPD[k]=False;
      }
      else
         DnPD[k]=False;
   }
        
   if (UD==0 && DnPD[k])UD=1;  
   if (UD==0 && UpPD[k])UD=2;  
     
   if (UpPD[k]==True) {
        ObjectCreate("PD"+k,OBJ_ARROW,0,Time[N1+k],High[N1+k]);
        ObjectSet("PD"+k,OBJPROP_ARROWCODE,SYMBOL_ARROWUP);
   }
        
   if (DnPD[k]==True) {
        ObjectCreate("PD"+k,OBJ_ARROW,0,Time[N1+k],Low[N1+k]);
        ObjectSet("PD"+k,OBJPROP_ARROWCODE,SYMBOL_ARROWDOWN);
   }
        
   if (UpPD[k]==True && skUp<N2){
      skUp=skUp+1;
      if (minmin==0 || minmin>Low[N1+k] ) minmin=Low[N1+k];
   }   
               
   if (DnPD[k]==True && skDn<N2){
      skDn=skDn+1;
      if (maxmax==0 || maxmax<High[N1+k] ) maxmax=High[N1+k];
   }   
}

if ( UD==2 ){
   ObjectCreate("LineUp",OBJ_HLINE,0,0,minmin);       
   ObjectSet("LineUp",OBJPROP_COLOR,Red);
}
if ( UD==1 ) {
   ObjectCreate("LineDn",OBJ_HLINE,0,0,maxmax);       
   ObjectSet("LineDn",OBJPROP_COLOR,Blue);
}
         


return(0);
}  
//+------------------------------------------------------------------+
// Converts Periods to String to track Mult Orders on Same Pair diff TF
//+------------------------------------------------------------------+

string Cmt(int x){
return(DoubleToStr(x,0));
}

double TotalProfit(int start,int end){
   double pr=0;
   for(int i=0;i<10000;i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() ==comment ){
            if(OrderOpenTime() >= TestStart)pr=pr+OrderProfit();
         }
      }else{
         break;
      }  
   }
   return(pr);
}
//+------------------------------------------------------------------+
// Time Filter
//+------------------------------------------------------------------+
int TimeFilter(){
   if(Hour()>EndHour || Hour()<BeginHour){
      return(1);
   }
   return(0);
}
//+------------------------------------------------------------------+
// Calculates Current Orders on TF,Pair,EA
//+------------------------------------------------------------------+

int CalculateCurrentOrders(){
   int orders=0;
   
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && comment ==OrderComment() ){
            orders++;
         }
      }
   }
   
   return(orders);
}
 //+------------------------------------------------------------------+
// Trading Signal
//+------------------------------------------------------------------+
int TradeSignal(){
double PDmax[20], PDmin[20], minmin, maxmax, stMAINPrev, stSIGPrev, sl, tp;
   int    res, error, skUp, skDn , UD;
   bool   UpPD[20], DnPD[20];
     
     
   double cci=iCCI(NULL,0,14,5,0);
   
   for (int k=1; k<=20; k++){   
      UpPD[k]=True;
      DnPD[k]=True;
      PDmax[k]=High[N1+k];
      PDmin[k]=Low[N1+k];
  
      for (int d=1; d<=N1; d++){
         if (PDmax[k]>High[N1+k+d] && UpPD[k]==True) {
            if (PDmin[k]<Low[N1+k-d] && UpPD[k]==True){
               UpPD[k]=True;
            }
            else
               UpPD[k]=False;
         }
         else
            UpPD[k]=False;
         
         if (PDmax[k]>High[N1+k-d] && DnPD[k]==True){
            if (PDmin[k]<Low[N1+k+d] && DnPD[k]==True) {
               DnPD[k]=True;
            }
            else
               DnPD[k]=False;
         }
         else
            DnPD[k]=False;
             
         if (UpPD[k]==True && skUp<N2){
            skUp=skUp+1;
            if (minmin==0 || minmin>Low[N1+k] ) minmin=Low[N1+k];
         }   
            
         if (DnPD[k]==True && skDn<N2){
            skDn=skDn+1;
            if (maxmax==0 || maxmax<High[N1+k] ) maxmax=High[N1+k];
         }   
          
         if (UD==0 && DnPD[k])UD=1;  
         if (UD==0 && UpPD[k])UD=2;             
      }
   }
   int tCCI=0;
   if(UseCCI){
      if(cci<100 && cci>-100){
         tCCI=1;
      }
   }else{
      tCCI=1;
   }
  
   if ( UD==1  && maxmax<=Bid && tCCI==1){
      if(ReverseTradeSignal){
         return(1);
      }else{
         return(2);
      }
   }
        
 
//ja ir BUY signls
   if ( UD==2 && minmin >= Ask && tCCI==1){
      if(ReverseTradeSignal){
         return(2);
      }else{
         return(1); 
      }
   }
   
}

//+------------------------------------------------------------------+
//| Open Conditions                       |
//+------------------------------------------------------------------+
void Sendit(){
double sl,tp; int res,error;

  
     
      res = OrderSend(Symbol(),OP_SELL,lots,Bid,3,sl,tp,comment,MAGICMA,0,Blue); // def
      if(res<0){
         error=GetLastError();
         Print("Error = ",ErrorDescription(error));
      }
  
  }
void CheckForOpen(){
double sl,tp; int res,error;

  if(TradeSignal()==2){
      if (StopLoss==0) {sl=0;} else sl=Bid+Point*StopLoss;
      if (TakeProfit==0) {tp=0;} else tp=Bid-Point*TakeProfit;
     
      res = OrderSend(Symbol(),OP_SELL,lots,Bid,3,sl,tp,comment,MAGICMA,0,Blue); // def
      if(res<0){
         error=GetLastError();
         Print("Error = ",ErrorDescription(error));
      }
  }
  if(TradeSignal()==1){
      if (StopLoss==0) {sl=0;} else sl=Ask-Point*StopLoss;
      if (TakeProfit==0) {tp=0;} else tp=Ask+Point*TakeProfit;
   
      res = OrderSend(Symbol(),OP_BUY,lots,Ask,3,sl,tp,comment,MAGICMA,0,Red); // def
      if(res<0){
         error=GetLastError();
         Print("Error = ",ErrorDescription(error));
      }
  }
}   
  
//+------------------------------------------------------------------+
//| Close conditions                      |
//+------------------------------------------------------------------+
void CheckForClose(){

   for(int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);    
      if (OrderType()==OP_BUY && OrderMagicNumber()==MAGICMA && Symbol()==OrderSymbol() && OrderComment() ==comment ){
         if (TradeSignal()==2) {                          // MA SELL signals
            int res = OrderClose(OrderTicket(),OrderLots(),Bid,3,White); // close 
            if(res<0){
               int error=GetLastError();
               Print("Error = ",ErrorDescription(error));
            }
         }     
      } 
      if (OrderType()==OP_SELL && OrderMagicNumber()==MAGICMA && Symbol()==OrderSymbol() && OrderComment() ==comment ){
         if (TradeSignal()==1) {                          // MA BUY signals
            res = OrderClose(OrderTicket(),OrderLots(),Ask,3,White); // close 
            if(res<0){
               error=GetLastError();
               Print("Error = ",ErrorDescription(error));
            }
         }     
      }  
   }    
}
   

//+------------------------------------------------------------------+
// Set Tight TP
//+------------------------------------------------------------------+
void Scalp(){
double res;int error;
   for(int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() == comment ){
         if(OrderType()==OP_BUY){
            if(Bid - OrderOpenPrice() >= ScalpPips*Point){
               res = OrderClose(OrderTicket(),OrderLots(),Bid,3,White); // close 
               if(res<0){
                  error=GetLastError();
                  Print("Error = ",ErrorDescription(error));
               }
            }
         }
         if(OrderType()==OP_SELL){
            if(OrderOpenPrice() - Ask >= ScalpPips*Point){
               res = OrderClose(OrderTicket(),OrderLots(),Ask,3,White); // close 
               if(res<0){
                  error=GetLastError();
                  Print("Error = ",ErrorDescription(error));
               }
            }
         }
      }
   }
}

//+------------------------------------------------------------------+
// Step Trailing Stop
//+------------------------------------------------------------------+
void StepTrail(){
bool res;int error;
   for(int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() == comment ){
         if(OrderType()==OP_BUY){
            for(int v=10;v>0;v--){
               if(Bid - OrderOpenPrice() >= Trail1Step*Point*v){
                  double bnm=OrderOpenPrice()+Trail1Step*v-Flex;
                  ModifyStopLoss(bnm);  
                  break;
               }
            }
         }
         if(OrderType()==OP_SELL){
            for(v=10;v>0;v--){
               if(OrderOpenPrice()-Ask >= Trail1Step*Point*v){
                  double sdf=OrderOpenPrice()-Trail1Step*v+Flex;
                  ModifyStopLoss(sdf);
                  break;
               }
            }
         }
      }
   }
}

//+------------------------------------------------------------------+
// Traditional Trailing Stop
//+------------------------------------------------------------------+
void TrailingPositions() {
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() == comment ) {
        if (OrderType()==OP_BUY) {
          if (!ProfitTrailing || (Bid-OrderOpenPrice())>TrailingStop*Point) {
            if (OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*Point) {
              ModifyStopLoss(Bid-TrailingStop*Point);
            }
          }
        }
        if (OrderType()==OP_SELL) {
          if (!ProfitTrailing || OrderOpenPrice()-Ask>TrailingStop*Point) {
            if (OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss()==0) {
              ModifyStopLoss(Ask+TrailingStop*Point);
            }
          }
        }
      }
    }
  }
}

//+------------------------------------------------------------------+
// Order Modify function
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStop) {
  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=100*Point;

  fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, Pink);
  
}
//+------------------------------------------------------------------+
// Emails the Closed order as soon as it hits the history.
//+------------------------------------------------------------------+
void MailAlert(){
int f =0;
   for(int i=0;i<10000;i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() == comment ){
            f++;
         }
      }else{
         break;
      }  
   }
   //Comment(" Trades in History ",f," Init cnt ",k  );
   if(k < f){
      string ordertyp;
      
      OrderSelect(f,SELECT_BY_POS,MODE_HISTORY);
      if(OrderType()==0)ordertyp="BUY";
      if(OrderType()==1)ordertyp="SELL";
     // SendMail("HI","HI");
      SendMail("CLOSED TRADE - STI - "+DoubleToStr(OrderProfit(),2),"  "+Symbol()+"    OpenTime: "+TimeToStr(OrderOpenTime())+"   Close Time: "+TimeToStr(OrderCloseTime())+"                     "+
      "Order Type "+ordertyp+"   Open "+DoubleToStr(OrderOpenPrice(),4)+"   Close "+DoubleToStr(OrderClosePrice(),4)+"  Profit ("+DoubleToStr(OrderProfit(),4)+")" );
      k++;
   }
 return;
} 
      
//+------------------------------------------------------------------+
// Safety net for trading.  Creates a total equity Stoploss
//+------------------------------------------------------------------+      
      
int EquitySL(){
static double eqhi;
   if(AccountEquity()>eqhi)eqhi=AccountEquity();
   if(AccountEquity() < eqhi * (( 100 - EquityRisk)/100))return(1);
return(0);
}

   
//+------------------------------------------------------------------+
// Expert Function
//+------------------------------------------------------------------+ 
int start(){
   Comment("\n",comment);
   if ((UseScalpIt && UseStepTrail)||(UseStepTrail && UseTradTrail) || (UseTradTrail && UseScalpIt)){
      Comment(" ERROR:  CANNOT USE MULTIPLE EXITING CRITERIA PLEASE CHANGE CRITERIA IN PROPERTIES ");
      return;
   }

   if(Bars<100 || IsTradeAllowed()==false) return;

   if(CalculateCurrentOrders()==0) {
      if (UseTotalEquitySL && EquitySL()==1){
      Comment("Total Equity StopLoss Hit --------HUMAN INTERVENTION IS REQUIRED--------------");
      Alert("HUMAN INTERVENTION IS REQUIRED");
      return;
      }
      if(UseTimeFilter && TimeFilter()==1)return;
      CheckForOpen();
   }else{ 
      CheckForClose();
   }
   
   if(UseScalpIt) {Scalp();}
   if(UseStepTrail){StepTrail();}
   if(UseTradTrail){TrailingPositions();}
   if(UseEmailAlerts){MailAlert();}
   
   return(0);
}
//+------------------------------------------------------------------+
// developed by Joke modified by Nicholishen
//+------------------------------------------------------------------+


